=== debian/changelog ===
opa-ff (10.9.3.1.1-2) unstable; urgency=low

  [ Brian T. Smith ]
  * New Standards-Version 4.4.1, no changes required
  * Specify Build-Depends-Package in shlib symbols
  * Specify Build-Depends debhelper >= 12 in d/control

  [ Roland Fehrenbacher ]
  * New upstream release
  * Update patches for new upstream (some have become obsolete)
  * Adjust d/README.source since dfsg version is no longer needed

 -- Roland Fehrenbacher <rf@q-leap.de>  Sat, 12 Oct 2019 18:50:13 +0000
